#!/usr/bin/awk -f
#   Copyright (C)2009..2019 @BABOLO http://www.babolo.ru/
#   PKG = cipalib
#   All rights reserved.
#
#   Redistribution and use in source and binary forms, with or without
#   modification, are permitted provided that the following conditions
#   are met:
#   1. Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must reproduce the above copyright
#      notice, this list of conditions and the following disclaimer in the
#      documentation and/or other materials provided with the distribution.
#
#   THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
#   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
#   ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
#   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
#   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
#   OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
#   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
#   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
#   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
#
#   $Id: pnode.awk,v 1.2 2019/10/05 01:08:13 babolo Exp $
#

BEGIN{
    q = 32767; #     
    a = "";
}

#{   sub("\r$", "")
#}

{   c = 0;
    if  (q >= FNR) { #   
        a = "";  #   
        b = -10; #    
        d = 10;  #    
        n = b;   #   
        g = 1000 #   
    }
    q = FNR;
}

(/^[ 	]*#/ || /^[ 	]*$/ ) { #  
    c = 1;
}

!c && (a != "") && /^[ 	]=/ { #    
    if  ($1 == "=") {
        i = $2
    } else {
        i = $1
        sub(/^=/, "", i)
    }
    if  (i == "") {           # 
        n = int((n + g - b) / g) * g
    } else {                  #  
        n = i
    }
    c = 1;
}

!c && (a != "") && /^[ 	]/ {
    if  ($1 ~ /^\+\(/) { # 
        r = $1;
        w = $2;
        s = $3;
        y = $4;
        z = $5;
        if  (r == "+(") {
            r = w;
            w = s;
            s = y;
            y = z;
        } else {
            sub(/^\+\(/, "", r);
        }
        if  (s == ")") {
            s = y;
        } else {
            sub(/\)$/, "", w);
        }
        gsub("'", "%27", s);
        gsub("\\?", "%3F", s);
        gsub("\\\\", "%5C", s);
        if  (s == "") s = "\\N";
        print 4 "	" n "	" p "	" r "	" w "	" a "	" s >> pleaf;
    } else if ($1 ~ /^\+/) { #  
        w = $1;
        s = $2;
        y = $3;
        if  (w == "+") {
            w = s;
            s = y;
        } else {
            sub(/^\+/, "", w);
        }
        gsub("'", "%27", s);
        gsub("\\?", "%3F", s);
        gsub("\\\\", "%5C", s);
        if  (s == "") s = "\\N";
        print 3 "	" n "	" p "	\\N	" w "	" a "	" s >> pleaf;
    } else if ($1 ~ /^\(/) { # 
        r = $1;
        w = $2;
        s = $3;
        y = $4;
        z = $5;
        if  (r == "(") {
            r = w;
            w = s;
            s = y;
            y = z;
        } else {
            sub(/^\(/, "", r);
        }
        if  (s == ")") {
            s = y;
        } else {
            sub(/\)$/, "", w);
        }
        gsub("'", "%27", s);
        gsub("\\?", "%3F", s);
        gsub("\\\\", "%5C", s);
        if  (s == "") s = "\\N";
        print 2 "	" n "	" p "	" r "	" w "	" a "	" s >> pleaf;
    } else if (NF > 1) { #    
        r = $1;
        w = $2;
        s = $3;
        gsub("'", "%27", s);
        gsub("\\?", "%3F", s);
        gsub("\\\\", "%5C", s);
        if  (s == "") s = "\\N";
        print 1 "	" n "	" p "	" r "	" w "	" a "	" s >> pleaf;
    } else if (NF == 1) { #    
        print 1 "	" n "	" p "	\\N	" $1 "	" a "	\\N" >> pleaf;
    }
    n += d;
    c = 1;
}

!c && /^=/ { # - .
    if  ($1 == "=") {
        a = $2
        p = $3
    } else {
        a = $1
        sub(/^=/, "", a)
        p = $2
    }
    n = b; #  
    c = 1;
}

!c && !/^[ 	]/ { #  
    p = $1;
    a = "\\N";
    n = b; #  
    sub(/^[^ 	]+[ 	]?/, "");
    print p "	" $0 >> pnode; #    
    c = 1;
}
